package org.vishia.gral.ifc;

/**This interface is used to adapt the widget manager to the application frame.
 * It is implemented by {@link org.vishia.gral.area9.GralArea9Window}.
 * @author Hartmut Schorrig
 *
 */
public interface GralMngApplAdapter_ifc
{
  /**Version, history and license.
   * <ul>
   * <li>2011-06-00 Hartmut created
   * </ul>
   * 
   * <b>Copyright/Copyleft</b>:<br>
   * For this source the LGPL Lesser General Public License,
   * published by the Free Software Foundation is valid.
   * It means:
   * <ol>
   * <li> You can use this source without any restriction for any desired purpose.
   * <li> You can redistribute copies of this source to everybody.
   * <li> Every user of this source, also the user of redistribute copies
   *    with or without payment, must accept this license for further using.
   * <li> But the LPGL is not appropriate for a whole software product,
   *    if this source is only a part of them. It means, the user
   *    must publish this part of source,
   *    but doesn't need to publish the whole source of the own product.
   * <li> You can study and modify (improve) this source
   *    for own using or for redistribution, but you have to license the
   *    modified sources likewise under this LGPL Lesser General Public License.
   *    You mustn't delete this Copyright/Copyleft inscription in this source file.
   * </ol>
   * If you intent to use this source without publishing its usage, you can get
   * a second license subscribing a special contract with the author. 
   * 
   * @author Hartmut Schorrig = hartmut.schorrig@vishia.de
   */
  public static final int version = 20120303;

  /**For context sensitive help, it assigns an URL to the widget which has the focus gained.
   * @param url A "file#html.label" or "localdir/file.html#label" which describes the html help url
   *   in an local context. The origin of the url is given with a global context of the help window.
   *   See {@link org.vishia.gral.area9.GralArea9Window#setHelpBase(String)}
   *   
   *   deprecated: It is often an absolute path. may be a relative path??
   *   deprecated: If it starts with "+", a base path is used as prefix.
   *  
   */
  void setHelpUrl(String url);
}
